#!/bin/sh
. `dirname $0`/../func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

echo 0 > /sys/class/graphics/fbcon/cursor_blink

GRAB_RES="640x480"
FRAME_SIZE=",width=640,height=480"
OFFSET_SENSOR="976,732"

echo "==============================================================="
echo "starting gstreamer with Bayer Source ..."
echo "read 648x486 (skip 4), and write to framebuffer 648x486"
echo "==============================================================="
echo ""
echo "configure CSI camnera port with media_control"
echo "============================================="

media-ctl -r
media-ctl -l ''$CAM_ENTITY_NUMBER'0->"csi":0[1]'
media-ctl -l "'csi':1->'csi capture':0[1]"
#           Camera -> CSI -> CSI capture (/dev/videoX)

media-ctl -V ''$CAM_ENTITY_NUMBER'0 [fmt:'$CAM_COL_FMT'/'$GRAB_RES' ('$OFFSET_SENSOR')/'$GRAB_RES']'
media-ctl -V '"csi":1 [fmt:'$CAM_COL_FMT'/'$GRAB_RES']'


echo ""
echo " configure camera with v4l2_control"
echo " =================================="

$V4L2_CTRL_CAM0


echo ""
echo "start gstreamer, break with ctl-C"
echo "================================="

gst-launch-1.0 \
	v4l2src device=$CAM_DEVICE ! \
	video/x-$COL_FORMAT$FRAME_SIZE ! \
	bayer2rgbneon ! \
	videoconvert ! \
	fbdevsink sync=false

echo 1 > /sys/class/graphics/fbcon/cursor_blink